# Describing use of required reason API

Apple is now requiring apps to list the reason for certan APIs that can be used for fingerprinting. 

As of 17.04.24 there are some issues with `PrivacyInfo` files defined in dependencies and being omitted. Thus triggering the warning email when submitting for review. 

As a temporary solution we need to define the following reasons in the main target even though those APIs aren't directly used, particularly: 

- NSPrivacyAccessedAPICategorySystemBootTime - https://github.com/Alamofire/Alamofire/issues/3847
- NSPrivacyAccessedAPICategoryDiskSpace - https://github.com/devicekit/DeviceKit/issues/404

The APIs we're using in our codebase are: 

- NSPrivacyAccessedAPICategoryFileTimestamp
- NSPrivacyAccessedAPICategoryUserDefaults


## For the poor developer touching this in the future, in case Apple takes its sweet time to fix this

go into the App package folder 
 usually in ~/Library/Developer/Xcode/DerivedData/YAZIO-random-hash-in-your-machine/Build/Products/Debug-iphonesimulator 
 and run these commands setting the API you'd want to find as a temp env var
 
### example
- API_TO_FIND=NSPrivacyAccessedAPICategoryFileTimestamp
- find . -type d -name '*.bundle' -exec sh -c 'grep -l $API_TO_FIND "{}"/*.xcprivacy 2>/dev/null' \;

this will give you a hint of which dependencies might be causing trouble


## Docs
https://developer.apple.com/documentation/bundleresources/privacy_manifest_files/describing_use_of_required_reason_api
